#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include "OrbTypes.h"
#include "Orb_glob.h"


#define true 1
#define false 0

int getaddr(void);
void getid(char *id);
char flash(void);
void ReportError(char * ErrorString);

DWORD GetOrbitFunctionAddresses (HINSTANCE hOrbitLib);
int ChoseOrbitNetwork(int NumberOfOrbitNetworks);

//console routines
void ClearScreen(HANDLE hConsole);
void SetCursor(HANDLE hConOut, BOOL CursorState);
void PositionCursor(HANDLE hConOut,SHORT X,SHORT Y);

tOrbitRst           OrbitRst;
tOrbitNotify        OrbitNotify;
tOrbitSetaddr       OrbitSetaddr;
tOrbitClr           OrbitClr;
tOrbitIdentify      OrbitIdentify;
tOrbitGetinfo       OrbitGetinfo;
tOrbitGetstatus     OrbitGetstatus;
tOrbitRead1         OrbitRead1;
tOrbitRead2         OrbitRead2;
tOrbitAcquire       OrbitAcquire;
tOrbitTrigger       OrbitTrigger;
tOrbitReadia        OrbitReadia;
tOrbitDifference    OrbitDifference;
tOrbitStartdiff     OrbitStartdiff;
tOrbitStopdiff      OrbitStopdiff;
tOrbitReaddiff1     OrbitReaddiff1;
tOrbitReaddiff2     OrbitReaddiff2;
tOrbitPreset        OrbitPreset;
tOrbitRefmark       OrbitRefmark;
tOrbitDirection     OrbitDirection;
tOrbitSetmode       OrbitSetmode;
tOrbitControl       OrbitControl;
tOrbitReadbuffer1   OrbitReadbuffer1;

/* "Non 485 comms" Orbit Interface Routines */

tConnectToOrbitNetworks         ConnectToOrbitNetworks;
tDisconnectFromOrbitNetworks    DisconnectFromOrbitNetworks;
tResetNetworkController         ResetNetworkController;
tGetOrbitNetworkNameAndType     GetOrbitNetworkNameAndType;
tReportOrbitProbeAssignment     ReportOrbitProbeAssignment;
tReportOrbitInterfaceVersion    ReportOrbitInterfaceVersion;
tReportOrbitError               ReportOrbitError;

int main(void)
{
	char Tempid[11];
	char id[11];
	int oaddr;
	int OrbitCmdChoice;
	int OrbitStatus;
	int	status;
	int rd;
	long rdlong;
	long RdgAtRefmarkSaved = 0;
	int NetworkNumber;
	int NumberOfOrbitNetworks;
	long RdgAtDatum = 0;

	BOOL RefmarkSaved = false;

	HANDLE hConOut = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleTitle("Orbit Network - Win32 Console mode example.");

	//** Load Orbit_IF.dll
	HINSTANCE hOrbitLib = LoadLibrary("Orbit_IF.dll");

	if(hOrbitLib == NULL)
	{
		ReportError("Loading of library 'Orbit_IF.dll' Failed ");
		return(0);
	}

	SetLastError(0);	//LoadLibrary successful, clear LastError

	//Get Orbit Function Addresses
	if(GetOrbitFunctionAddresses (hOrbitLib) != 0)
	{
		ReportError("GetOrbitFunctionAddresses Failed ");
		return(0);
	}


	//Get the number of Orbit Networks
	if(ConnectToOrbitNetworks(&NumberOfOrbitNetworks) != 0)
	{
		ReportError("ConnectToOrbitNetworks Failed ");
		return(0);
	}

	//Get Orbit Networks to use
	NetworkNumber =	ChoseOrbitNetwork(NumberOfOrbitNetworks);
	if(NetworkNumber < 0)
	{
 		ReportError("ChoseOrbitNetwork Failed");
		return(0);
	}

	OrbitRst(NetworkNumber);
	strcpy(Tempid,  "xxxxxxxxxx");

	BOOL ExitOrbitProgram = false;
	do
	{
		printf ("\n\n");
		printf ("1 =OrbitRst         2 =OrbitNotify       3 =OrbitSetaddr    4 =OrbitClr \n");
		printf ("5 =OrbitRead1       6 =OrbitIdentify     7 =OrbitGetstatus  8 =OrbitDifference \n");
		printf ("9 =OrbitStartdiff   10=OrbitStopdiff     11=OrbitReaddiff1  12=OrbitAcquire \n");
		printf ("13=OrbitTrigger     14=OrbitReadia       15=OrbitRead2      16=OrbitPreset \n");
		printf ("17=OrbitRefmark     18=OrbitReaddiff2    19=OrbitDirection  20=Orbitgetinfo\n");
                printf ("21=OrbitSetmode     22=OrbitControl      23=OrbitReadbuffer1\n");
                printf ("\nEnter Choice: (0=QUIT) ? ");
	        scanf("%i",&OrbitCmdChoice);
		printf ("\n");
        	fflush(stdin);

		switch(OrbitCmdChoice)
		{
		case 0:
                      	printf("\n");
	        	ExitOrbitProgram = true;
			break;

		//***************************************************************************
		//*                           OrbitRst Command.
		//***************************************************************************
		case 1:
			printf("calling OrbitRst:(NetworkNumber=%d)\n",NetworkNumber);
			OrbitStatus = OrbitRst(NetworkNumber);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
			strcpy(Tempid,  "xxxxxxxxxx");
         	break;

		//***************************************************************************
		//*                           OrbitNotify Command.
		//***************************************************************************
		case 2:
			ClearScreen(hConOut);
			SetCursor(hConOut,false);	//turn cursor off
			strcpy(Tempid,  "xxxxxxxxxx");
			do
			{
				OrbitStatus = OrbitNotify(NetworkNumber,Tempid);
				PositionCursor(hConOut,0,0);
				printf("calling OrbitNotify:(NetworkNumber=%d , id=%s )\n",NetworkNumber,Tempid);
				printf("OrbitStatus=%xh   \n",OrbitStatus);
				printf( "Running [%c] - Press Probe Tip or Any Key To Return To Menu",flash());
			}while(OrbitStatus == 0xff && !kbhit());
			SetCursor(hConOut,true);	//turn cursor on
			//_settextposition(4 , 1);
			break;

		//***************************************************************************
		//*                           OrbitSetaddr Command.
		//***************************************************************************
		case 3:
			int opt;
			oaddr = getaddr();
			//use Tempid$ from Notify if valid
			if(strcmp(Tempid,"xxxxxxxxxx") != 0)
			{
				printf("id$ (from Notify) = %s \n",Tempid);
				strcpy(id, Tempid);
			}
			else
				getid(id);

			opt = 0;
			printf("calling OrbitSetaddr:(NetworkNumber=%d  , oaddr=%d, id=%s , opt=%d)\n",NetworkNumber,oaddr,id,opt);
			OrbitStatus = OrbitSetaddr(NetworkNumber,oaddr,id,&opt);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
			break;

		//***************************************************************************
		//*                           OrbitClr Command.
		//***************************************************************************
		case 4:
			oaddr = getaddr();
			printf("called OrbitClr:(NetworkNumber=%d  , oaddr=%d)\n",NetworkNumber,oaddr);
			OrbitStatus = OrbitClr(NetworkNumber,oaddr);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
			break;

		//***************************************************************************
		//*                           OrbitRead1 Command.
		//***************************************************************************
		case 5:
			oaddr = getaddr();
			ClearScreen(hConOut);
			SetCursor(hConOut,false);	//turn cursor off
			do
			{
				PositionCursor(hConOut,0,0);
				rd=0;
				OrbitStatus = OrbitRead1(NetworkNumber,oaddr,&rd);
	            printf("called OrbitRead1:(NetworkNumber=%d , oaddr=%d , rd=%d)    \n",NetworkNumber,oaddr,rd);
				printf("OrbitStatus=%xh   \n",OrbitStatus);
				printf( "Running [%c] - Press Probe Tip or Any Key To Return To Menu",flash());
			}while(OrbitStatus != 0xff && !kbhit());
			SetCursor(hConOut,true);	//turn cursor on
			break;

		//***************************************************************************
		//*                           OrbitIdentify Command.
		//***************************************************************************
		case 6:
			char devtype[13];
			char ver[7];
			int stroke;

			oaddr = getaddr();
			strcpy(id, "          ");
			strcpy(devtype, "            ");
			strcpy(ver, "     ");
			stroke = 0;
			OrbitStatus = OrbitIdentify(NetworkNumber,oaddr,id,devtype,ver,&stroke);
			printf("called OrbitIdentify:(NetworkNumber=%d , oaddr=%d , id=%s \n                 devtype=%s, ver=%s, stroke=%d)\n",NetworkNumber,oaddr,id,devtype,ver,stroke);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
			break;

		//***************************************************************************
		//*                           OrbitGetstatus Command.
		//***************************************************************************
		case 7:
			int errcode;

			oaddr = getaddr();
			errcode = 0;
			status = 0;
			OrbitStatus = OrbitGetstatus(NetworkNumber,oaddr,&errcode,&status);
			printf("called OrbitGetstatus:(NetworkNumber=%d  oaddr=%d , errcode=%xh , status=%xh)\n",NetworkNumber,oaddr,errcode,status);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
			break;

		//***************************************************************************
		//*                           OrbitDifference Command.
		//***************************************************************************
		case 8:
			oaddr = getaddr();
			OrbitStatus = OrbitDifference(NetworkNumber,oaddr);
			printf("called OrbitDifference:(NetworkNumber=%d , oaddr=%d)\n",NetworkNumber,oaddr);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
			break;

		//***************************************************************************
		//*                           OrbitStartdiff Command.                        
		//***************************************************************************
		case 9:
			OrbitStatus = OrbitStartdiff(NetworkNumber);
			printf("called OrbitStartdiff:(NetworkNumber=%d)\n",NetworkNumber);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
		break;

		//***************************************************************************
		//*                           OrbitStopdiff Command.
		//***************************************************************************
		case 10:
			OrbitStatus = OrbitStopdiff(NetworkNumber);
			printf("called OrbitStopdiff:(NetworkNumber=%d)\n",NetworkNumber);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
		break;

		//***************************************************************************
		//*                           OrbitReaddiff1 Command.
		//***************************************************************************
		case 11:
			int min;
			int max;
			double sum;
			long num;

			oaddr = getaddr();
			ClearScreen(hConOut);
			SetCursor(hConOut,false);	//turn cursor off
			do
			{
				min = 0;
				max = 0;
				sum = 0;
				num = 0;
				PositionCursor(hConOut,0,0);
				OrbitStatus = OrbitReaddiff1(NetworkNumber,oaddr,&min,&max,&sum,&num);
				printf("called OrbitReaddiff1:(NetworkNumber=%d , oaddr=%d ,\n",NetworkNumber,oaddr);
				printf("                       min=%d , max=%d ,         \n",min,max);
				printf("                       sum=%12.0f , num=%d)        \n",sum,num);
				printf("OrbitStatus=%xh   \n",OrbitStatus);
				printf( "Running [%c] - Press Any Key To Return To Menu",flash());
			}while(OrbitStatus == 0 && !kbhit());
			SetCursor(hConOut,true);	//turn cursor on
			break;

		//***************************************************************************
		//*                           OrbitAcquire Command.
		//***************************************************************************
		case 12:
			int dly;
			int rdgs;

			oaddr = getaddr();
			printf("Enter dly ? ");
			scanf("%i",&dly);
			printf("Enter rdgs ? ");
			scanf("%i",&rdgs);
			OrbitStatus = OrbitAcquire(NetworkNumber,oaddr,&rdgs,&dly);
			printf("called OrbitAcquire:(NetworkNumber=%d , oaddr=%d , rdgs=%d , dly=%d )\n",NetworkNumber,oaddr,rdgs,dly);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
			break;

		//***************************************************************************
		//*                           OrbitTrigger Command.
		//***************************************************************************
		case 13:
			OrbitStatus = OrbitTrigger(NetworkNumber);
			printf("called OrbitTrigger:(NetworkNumber=%d)\n",NetworkNumber);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
			break;

		//***************************************************************************
		//*                           OrbitReadia Command.
		//***************************************************************************
		case 14:
			int rdarray[25];
			int index;

			for (index=0;index<25;index++)
				rdarray[index] = 0;
			oaddr = getaddr();
			ClearScreen(hConOut);
			SetCursor(hConOut,false);	//turn cursor off
			do
			{
				PositionCursor(hConOut,0,0);
	            OrbitStatus = OrbitReadia(NetworkNumber, oaddr, rdarray);
				printf("called OrbitReadia:(NetworkNumber=%d , oaddr=%d , rdarray:-\n",NetworkNumber,oaddr);
				for (index=0;index<5;index++)
				{
					printf("rdg%2d %6d",index+1,rdarray[index]);
					printf("  rdg%2d %6d",index+6,rdarray[index+5]);
					printf("  rdg%2d %6d",index+11,rdarray[index+10]);
					printf("  rdg%2d %6d",index+16,rdarray[index+15]);
					printf("  rdg%2d %6d",index+21,rdarray[index+20]);
					printf("\n");
				}
				printf("OrbitStatus=%xh   \n",OrbitStatus);
				printf( "Running [%c] - Press Any Key To Return To Menu",flash());
			}while(OrbitStatus == 0 && !kbhit());
			SetCursor(hConOut,true);	//turn cursor on
			break;

		//***************************************************************************
		//*                           OrbitRead2 Command.
		//***************************************************************************
		case 15:
			oaddr = getaddr();
			ClearScreen(hConOut);
			SetCursor(hConOut,false);	//turn cursor off
			do
			{
				PositionCursor(hConOut,0,0);
				rdlong=0;
				OrbitStatus = OrbitRead2(NetworkNumber,oaddr,&rdlong);
				printf("called OrbitRead2:(NetworkNumber=%d , oaddr=%d , rdlong= %ld)      \n",NetworkNumber,oaddr,rdlong);
				printf("OrbitStatus=%xh   \n",OrbitStatus);
				printf( "Running [%c] - Press Any Key To Return To Menu",flash());
			}while(OrbitStatus != 0xff && !kbhit());
			SetCursor(hConOut,true);	//turn cursor on
			break;

		//***************************************************************************
		//*                           OrbitPreset Command.
		//***************************************************************************
		case 16:
			long pstlong;

			oaddr = getaddr();
			printf("Enter Preset ");
			scanf("%ld",&pstlong);
			OrbitStatus = OrbitPreset(NetworkNumber,oaddr,&pstlong);
			printf("called OrbitPreset:(NetworkNumber=%d , oaddr=%d, preset=%ld)\n",NetworkNumber,oaddr,pstlong);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
			break;

		//***************************************************************************
		//*                           OrbitRefmark Command.
		//***************************************************************************
		case 17:
			#define REFFOUNDBIT 0x8
			int refchoice;
			int status;
			long RdgAtRefmark;
			long RefOffset;

			oaddr = getaddr();
			ClearScreen(hConOut);
			printf("Example of Reference mode operation\n");
			printf("Recall=1   New=2 \n");
			printf ("Enter Choice: (1 or 2) ? ");
			scanf("%i",&refchoice);

			switch(refchoice)
			{
			case 1:
				printf("\nReference mode - Recall\n");
				//set to ref mark mode
				if(RefmarkSaved == 0)
					printf("Refmark not saved: Use Reference mode - New.\n");
				else
				{
					OrbitStatus = OrbitRefmark(NetworkNumber,oaddr);
					if(OrbitStatus == 0)
					{
						printf("Move Probe tip through Ref Marker\n");
						do
						{
							status = 0;
							OrbitStatus = OrbitGetstatus(NetworkNumber,oaddr,&errcode,&status);
							if(OrbitStatus != 0) break;
                  }while((status &  REFFOUNDBIT)==0 && !kbhit());

						//get probe reading at reference mark
						OrbitStatus = OrbitRead2(NetworkNumber,oaddr,&rdlong);
			 			printf("OrbitStatus=%xh   \n",OrbitStatus);
						RdgAtRefmark = rdlong;
						printf("RdgAtRefmark(recalled)=%ld\n", RdgAtRefmarkSaved);
						printf("RdgAtRefmark(current)=%ld\n", RdgAtRefmark);
						RefOffset = RdgAtRefmark - RdgAtRefmarkSaved;
						printf("RefOffset=%ld\n",RefOffset);
						SetCursor(hConOut,false);	//turn cursor off
						do
						{
							PositionCursor(hConOut,10,0);
							rdlong=0;
							OrbitStatus = OrbitRead2(NetworkNumber,oaddr,&rdlong);
							printf("called OrbitRead2:(NetworkNumber=%d , oaddr=%d , ",NetworkNumber,oaddr);
							printf("compensated rdlong =%ld)    \n",rdlong-RdgAtDatum-RefOffset);
							printf( "Running [%c] - Press Any Key To Return To Menu",flash());
						}while(OrbitStatus != 0xff && !kbhit());
						SetCursor(hConOut,true);	//turn cursor on
					}
					else
					{
						printf("called OrbitRefmark:(NetworkNumber=%d , oaddr=%d )\n",NetworkNumber,oaddr);
						printf("OrbitStatus=%xh   \n",OrbitStatus);
					}
				}
				break;

			case 2:
				printf("\nReference mode - New\n");
				printf("set machine (probe) datum, then press any key\n");

				do{;}while(!kbhit());
				getch();

				//get current probe reading
				OrbitStatus = OrbitRead2(NetworkNumber,oaddr,&rdlong);
				if(OrbitStatus == 0)
				{
					RdgAtDatum = rdlong;
					printf("RdgAtDatum=%ld\n", RdgAtDatum);

					//set to ref mark mode
					OrbitStatus = OrbitRefmark(NetworkNumber,oaddr);
					printf("OrbitStatus=%xh   \n",OrbitStatus);
					printf("Move Probe tip through Ref Marker\n");
					do
					{
						status = 0;
						OrbitGetstatus(NetworkNumber,oaddr,&errcode,&status);
					}while((status &  REFFOUNDBIT)==0 && !kbhit());

					//get probe reading at reference mark
					rdlong=0;
					OrbitRead2(NetworkNumber,oaddr,&rdlong);
		 			RdgAtRefmark = rdlong;
					printf("RdgAtRefmark=%ld (could be saved in a file, to make non volatile)\n",RdgAtRefmark);
					RdgAtRefmarkSaved = RdgAtRefmark;
					ClearScreen(hConOut);
					SetCursor(hConOut,false);	//turn cursor off
					do
					{
						PositionCursor(hConOut,10,0);
						rdlong=0;
						OrbitStatus = OrbitRead2(NetworkNumber,oaddr,&rdlong);
						printf("called OrbitRead2:(NetworkNumber=%d , oaddr=%d , ",NetworkNumber,oaddr);
						printf("compensated rdlong =%ld)    \n",rdlong-RdgAtDatum);
						printf( "Running [%c] - Press Any Key To Return To Menu",flash());
					}while(OrbitStatus != 0xff && !kbhit());
					SetCursor(hConOut,true);	//turn cursor on
					RefmarkSaved = true;
					printf ("\n\n");
				}
				else
				{
					printf("called OrbitRead2:(NetworkNumber=%d , oaddr=%d , reading= %ld)\n",NetworkNumber,oaddr,rdlong);
					printf("OrbitStatus=%xh   \n",OrbitStatus);
				}
				break;
			};
			break;

		//***************************************************************************
		//*                           OrbitReaddiff2 Command.
		//***************************************************************************
		case 18:
			long minlong;
			long maxlong;

			minlong=0;
			maxlong=0;
			oaddr = getaddr();
			ClearScreen(hConOut);
			SetCursor(hConOut,false);	//turn cursor off
			do
			{
				PositionCursor(hConOut,0,0);
				OrbitStatus = OrbitReaddiff2(NetworkNumber,oaddr,&minlong,&maxlong);
				printf("called OrbitReaddiff2:(NetworkNumber=%d , oaddr=%d,\n",NetworkNumber,oaddr);
				printf("                       minlong=%ld , maxlong=%ld)\n",minlong,maxlong);
				printf("OrbitStatus=%xh   \n",OrbitStatus);
				printf( "Running [%c] - Press Any Key To Return To Menu",flash());
			}while(OrbitStatus != 0xff && !kbhit());
			SetCursor(hConOut,true);	//turn cursor on
			break;

		//***************************************************************************
		//*                           OrbitDirection Command.
		//***************************************************************************
		case 19:
			oaddr = getaddr();
			OrbitStatus = OrbitDirection(NetworkNumber,oaddr);
			printf("called OrbitDirection:(NetworkNumber=%d , oaddr=%d)\n",NetworkNumber,oaddr);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
			break;

		//***************************************************************************
		//*                           OrbitGetinfo Command.
		//***************************************************************************
		case 20:
			int hwtype;
			int reso;
			char moduletype[5];
			char moduleinfo[33];

			oaddr = getaddr();
			strcpy(moduletype, "    ");
			hwtype=0;
			reso=0;
			strcpy(moduleinfo, "                                ");
			OrbitStatus = OrbitGetinfo(NetworkNumber,oaddr,moduletype,&hwtype,&reso,moduleinfo);
			printf("called OrbitGetinfo:(NetworkNumber=%d , oaddr=%d ,\n",NetworkNumber,oaddr);
			printf("                     moduletype=%s, hwtype=%d, reso=%d,\n",moduletype,hwtype,reso);
			printf("                     moduleinfo=%s)\n",moduleinfo);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
			break;

		//***************************************************************************
		//*                           OrbitSetmode Command
		//***************************************************************************
		case 21:
			int mode;
            printf("NOTE : If changing from buffered mode to normal mode\n");
            printf("       make sure buffer is empty before applying change.\n");
			oaddr = getaddr();
			printf("Enter mode ? ");
			scanf("%i",&mode);
			printf("Enter dly ? ");
			scanf("%i",&dly);
			OrbitStatus = OrbitSetmode(NetworkNumber,oaddr,&mode,&dly);
			printf("called OrbitSetmode:(NetworkNumber=%d , oaddr=%d , mode=%d , dly=%d )\n",NetworkNumber,oaddr,mode,dly);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
			break;

		//***************************************************************************
		//*                           OrbitControl Command
		//***************************************************************************
		case 22:
			int control;

			printf("Enter Control ? ");
			scanf("%i",&control);
			OrbitStatus = OrbitControl(NetworkNumber,&control);
			printf("called OrbitControl:(NetworkNumber=%d , contol =%d )\n",NetworkNumber,control);
			printf("OrbitStatus=%xh   \n",OrbitStatus);
			break;

    		//***************************************************************************
		//*                           OrbitReadbuffer1 Command
		//***************************************************************************
		case 23:
                        int NumberOfReadings;
                        int Readingbuffer1[32];


			oaddr = getaddr();
                        ClearScreen(hConOut);
			OrbitStatus = OrbitReadbuffer1(NetworkNumber,oaddr,&NumberOfReadings,&Readingbuffer1[0]);
			printf("called OrbitReadbuffer1: (NetworkNumber=%d , oaddr=%d , NumberOfReadings = %d\n",NetworkNumber,oaddr,NumberOfReadings);
                        printf("\n");
			for (index=0;index<NumberOfReadings;index++)
			{
				printf("rdg%2d %6d  ",index+1,Readingbuffer1[index]);
                                if((index+1)%4 == 0) // new line every 4 readings
				     printf("\n");
			}

			printf("\nOrbitStatus=%xh   \n",OrbitStatus);
			break;
                default:
           	       fflush(stdin);

		}// end switch
	}while(ExitOrbitProgram == false);

	DisconnectFromOrbitNetworks();
	FreeLibrary(hOrbitLib);
	return 0;

}//end of main

void ClearScreen(HANDLE hConOut)
{
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	COORD TopLeft = {0, 0};
	DWORD cCharsWritten;

	//get the console buffer size
    GetConsoleScreenBufferInfo(hConOut, &csbi);

	//fill the console buffer with spaces (' ')
    FillConsoleOutputCharacter(hConOut,' ',(csbi.dwSize.X * csbi.dwSize.Y),// - csbi.dwSize.X, /* number of chars */
        TopLeft,&cCharsWritten);

	//put the cursor at (0, 0) 
	SetConsoleCursorPosition(hConOut,TopLeft);
	return;
}

void SetCursor(HANDLE hConOut, BOOL CursorState)
{
	CONSOLE_CURSOR_INFO cci;
	GetConsoleCursorInfo(hConOut, &cci);
	cci.bVisible = CursorState;
	SetConsoleCursorInfo(hConOut, &cci);
	return;
}

void PositionCursor(HANDLE hConOut,SHORT X,SHORT Y)
{
	COORD Posn;
	Posn.X = X;
	Posn.Y = Y;
	SetConsoleCursorPosition(hConOut,Posn);
	return;
}



void ReportError(char * ErrorString)
{
	printf("%s\n", ErrorString);
	printf("%s\n","Press any key to Quit");
	while(!kbhit())
	{
	}
	return;
}

DWORD GetOrbitFunctionAddresses (HINSTANCE hOrbitLib)
{
	//** Get Orbit function addresses from Orbit_IF.dll
	OrbitRst = (tOrbitRst) GetProcAddress (hOrbitLib, "OrbitRst");
	OrbitNotify = (tOrbitNotify) GetProcAddress (hOrbitLib, "OrbitNotify");
	OrbitSetaddr = (tOrbitSetaddr) GetProcAddress (hOrbitLib, "OrbitSetaddr");
	OrbitClr = (tOrbitClr) GetProcAddress (hOrbitLib, "OrbitClr");
	OrbitIdentify = (tOrbitIdentify) GetProcAddress (hOrbitLib, "OrbitIdentify");
	OrbitGetinfo = (tOrbitGetinfo) GetProcAddress (hOrbitLib, "OrbitGetinfo");
	OrbitGetstatus = (tOrbitGetstatus) GetProcAddress (hOrbitLib, "OrbitGetstatus");
	OrbitRead1 = (tOrbitRead1) GetProcAddress (hOrbitLib, "OrbitRead1");
	OrbitRead2 = (tOrbitRead2) GetProcAddress (hOrbitLib, "OrbitRead2");
	OrbitAcquire = (tOrbitAcquire) GetProcAddress (hOrbitLib, "OrbitAcquire");
	OrbitTrigger = (tOrbitTrigger) GetProcAddress (hOrbitLib, "OrbitTrigger");
	OrbitReadia = (tOrbitReadia) GetProcAddress (hOrbitLib, "OrbitReadia");
	OrbitDifference = (tOrbitDifference) GetProcAddress (hOrbitLib, "OrbitDifference");
	OrbitStartdiff = (tOrbitStartdiff) GetProcAddress (hOrbitLib, "OrbitStartdiff");
	OrbitStopdiff = (tOrbitStopdiff) GetProcAddress (hOrbitLib, "OrbitStopdiff");
	OrbitReaddiff1 = (tOrbitReaddiff1) GetProcAddress (hOrbitLib, "OrbitReaddiff1");
	OrbitReaddiff2 = (tOrbitReaddiff2) GetProcAddress (hOrbitLib, "OrbitReaddiff2");
	OrbitPreset = (tOrbitPreset) GetProcAddress (hOrbitLib, "OrbitPreset");
	OrbitRefmark = (tOrbitRefmark) GetProcAddress (hOrbitLib, "OrbitRefmark");
	OrbitDirection = (tOrbitDirection) GetProcAddress (hOrbitLib, "OrbitDirection");
        OrbitSetmode = (tOrbitSetmode) GetProcAddress (hOrbitLib, "OrbitSetmode");
        OrbitControl = (tOrbitControl) GetProcAddress (hOrbitLib, "OrbitControl");
        OrbitReadbuffer1 = (tOrbitReadbuffer1) GetProcAddress (hOrbitLib, "OrbitReadbuffer1");

	ConnectToOrbitNetworks = (tConnectToOrbitNetworks) GetProcAddress (hOrbitLib, "ConnectToOrbitNetworks");
	DisconnectFromOrbitNetworks = (tDisconnectFromOrbitNetworks) GetProcAddress (hOrbitLib, "DisconnectFromOrbitNetworks");
	ResetNetworkController = (tResetNetworkController) GetProcAddress (hOrbitLib, "ResetNetworkController");
	GetOrbitNetworkNameAndType = (tGetOrbitNetworkNameAndType) GetProcAddress (hOrbitLib, "GetOrbitNetworkNameAndType");
	ReportOrbitProbeAssignment = (tReportOrbitProbeAssignment) GetProcAddress (hOrbitLib, "ReportOrbitProbeAssignment");
	ReportOrbitInterfaceVersion = (tReportOrbitInterfaceVersion) GetProcAddress (hOrbitLib, "ReportOrbitInterfaceVersion");
        ReportOrbitError = (tReportOrbitError) GetProcAddress (hOrbitLib,"ReportOrbitError");

	return (GetLastError());
}

int ChoseOrbitNetwork(int NumberOfOrbitNetworks)
{
	int Status;
	int NWNum;
	int NetworkType;
	char NetworkName[NUMBER_OF_CHARS_IN_NETWORK_NAME + 1];

	printf("Reporting Available Orbit Networks \n\n"
			 "Number  Name                           Type  \n"
			 "------  ----                           ----  \n");

	for (NWNum=0;NWNum<NumberOfOrbitNetworks;NWNum++)
	{
		//initialise NetworkName
		strncpy(NetworkName, DEFAULT_NETWORK_NAME,
				NUMBER_OF_CHARS_IN_NETWORK_NAME + 1);
		Status = GetOrbitNetworkNameAndType(NWNum,NetworkName,
											&NetworkType);
		if(Status != 0)
		{
			NWNum = -1;
			break;
		}
		printf("%d\t%s\t%d\n",NWNum, NetworkName, NetworkType);
	}
	if(Status == 0)
	{
		printf("\n");
		do
		{
			printf("Enter Network number required ");
			if (scanf("%i",&NWNum) == 0)
                            NWNum = 55; // set invalid number if no integer found
           		if(NWNum>=0 && NWNum<NumberOfOrbitNetworks) break;
			  {
                            printf("Bad number, retry\n\n");
                            fflush(stdin);
                          }
		}while(true);
	}
	return (NWNum);
}

int getaddr(void)
{
	int addr;
	do
	{
      printf("Orbit addr (1 - 31) \b\b");
      scanf("%i",&addr);
	}while(addr < 1 || addr > 31);
	return addr;
}

void getid (char *id)
{
	do
	{
		printf("id (10 characters) \b\b\b\b\b\b\b\b\b\b");
		scanf("%s",id);
	}while(strlen(id) != 10);
	return;
}

char flash (void)
{
	unsigned char character;
	if((GetTickCount() & 1000) > 500)
		character = '*';
	else
      character = ' ';
	return character;
}


